2023河南萌新联赛第(八)场 南阳理工学院F小前前




思路:

每次查询L - R的 最大连续子区间的或值

但是 我们都知道或的话 只会增加 不会减少

所以 L - R 的或值就是最大的子区间 然后再求与x的或值就ok了

但是 n=1e5 q=1e5

我们不能每次循环都暴力跑一边 那肯定是不行的

这里我们可以把他们拆成2进制 存放到二维数组里

a\[\]\[\] 第一层为第i个数 第二层为i层及之前所有数在二进制第j位的和

比如 有3个数

1 2 3

拆成2进制为 00 10 11

那么a10=0 a11=0

a20=1 a2\[1=0

a30]=2 a31 =1

总共就2^60 完全可以暴力拆解 最大60次

我们在求或值的时候 只需要

al - ar-1 即可

就可以获得这个区间的二进制数

然后我们就可以根据第j位是否存在二进制数 来选择是否 sum+=pow(2,j)

总代码如下`

另外需要注意的是 我用内置的pow 会错误

所以用到了快速幂

cpp 复制代码
#include <bits/stdc++.h>

using namespace std;
#define py cout << "YES\n";
typedef long long ll;

int a[100009][66];
int b[65];
ll c[100006];
//快速幂
ll quickPow(ll a, ll n){
    ll ans = 1;
    while(n>0){
        if(n&1>0)        //如果n的当前末位为1
            ans *= a;  //ans乘上当前的a
        a *= a;        //a自乘
        n >>= 1;       //n往右移一位,表示除以2
    }
    return ans;
}
int main(){
	int n,q;
	cin>>n>>q;
	for(int i=1;i<=n;i++){
		ll x;
		cin>>x;
		int cnt=0;
		for(int j=0;j<=62;j++) a[i][j]+=a[i-1][j];
		while(x){
			a[i][cnt++]+=x%2;
			x/=2;
		}
	}
	for(int i=0;i<q;i++){
		int l,r; ll x;
		ll sum=0;
		int t=0;
		memset(b,0,sizeof(b));
		cin>>l>>r>>x;
		while(x){
			b[t++]=x%2;
			x/=2;
		}
		for(int j=0;j<=62;j++){
			b[j]+=a[r][j]-a[l-1][j];
			if(b[j]) sum+=quickPow(2,j);
		//	printf("%d,%d\n",j ,b[j]);
		}
		c[i]=sum;
	}
	for(int i=0;i<q;i++) cout<<c[i]<<'\n';
	
}
相关推荐
longlongzihan3 小时前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
封印师请假去地球钓鱼3 小时前
边解边变的问题:从“决策依赖“一词出发
人工智能·算法
今晚打老虎4 小时前
c++之提高A(前缀和)(第三课)
数据结构·c++·算法
不会就选b5 小时前
算法日常・每日刷题--<贪心>26
数据结构·算法
hetao17338377 小时前
2026-09-29 hetao1733837 的刷题记录
c++·算法
欣欣之王来了7 小时前
AI合规专项:AI算法透明度的合规要求
人工智能·算法
wzdark7 小时前
分块思想在算法优化中的实践与应用4
算法
Because_of_Her17 小时前
dfs-洪水填充技巧
笔记·算法·深度优先·洪水填充
小静AI工程实验室8 小时前
RSA 算法详解:从模幂原理到 OAEP 加密、PSS 签名与 Python 实验
python·算法
xzal128 小时前
GESP Python笔记
笔记·python·算法